%--------------Cleaning the workspace and loading functions---------------%
clc;
clear     all;
close     all;
%-------------------------------------------------------------------------%

%-------------------Results Fig. 1 (a) and (b)----------------------------%
% Loading results
load      coupled_complex_non_collinear
% Coherency of the true factors
A_norm    =     A.*repmat(1./sqrt(real(sum(conj(A).*A))),dim(1),1);
coh_A     =     max(max(abs(A_norm'*A_norm)-eye(R)));
B_norm    =     B.*repmat(1./sqrt(real(sum(conj(B).*B))),dim(2),1);
coh_B     =     max(max(abs(B_norm'*B_norm)-eye(R)));
C_norm    =     C.*repmat(1./sqrt(real(sum(conj(C).*C))),dim(3),1);
coh_C     =     max(max(abs(C_norm'*C_norm)-eye(R)));
A_p_norm  =     A_p.*repmat(1./sqrt(real(sum(conj(A_p).*A_p))),dim_p(1),1);
coh_A_p   =     max(max(abs(A_p_norm'*A_p_norm)-eye(R)));
B_p_norm  =     B_p.*repmat(1./sqrt(real(sum(conj(B_p).*B_p))),dim_p(2),1);
coh_B_p   =     max(max(abs(B_p_norm'*B_p_norm)-eye(R)));
% Fig.1 (a) or (c) coupled factors
semilogy(SNR,total_mse_C_u,'k',...
     SNR,total_mse_C_p_u,'k:',...
     SNR,total_mse_C_c,'k--',...
     SNR,total_CRB_C_u,'b',...
     SNR,total_CRB_C_p_u,'b:',...
     SNR,total_CRB_C_c,'b--')
legend('MSE C uncoupled','MSE C_p uncoupled','MSE C coupled',...
       'CRB C uncoupled','CRB C_p uncoupled','CRB C coupled')
xlabel('SNR (dB)')
ylabel('Total MSE')
% Fig.1 (b) or (d) uncoupled factors
figure
semilogy(SNR,total_mse_AB_u,'k',...
     SNR,total_mse_AB_p_u,'k:',...
     SNR,total_mse_AB_c,'k--',...
     SNR,total_mse_AB_p_c,'k-.',...
     SNR,total_CRB_AB_u,'b',...
     SNR,total_CRB_AB_p_u,'b:',...
     SNR,total_CRB_AB_c,'b--',...
     SNR,total_CRB_AB_p_c,'b-.')
legend('MSE AB uncoupled','MSE AB_p uncoupled',...
       'MSE AB coupled','MSE AB_p coupled',...
       'CRB AB uncoupled','CRB AB_p uncoupled',...
       'CRB AB coupled','CRB AB_p coupled')
xlabel('SNR (dB)')
ylabel('Total MSE')
%-------------------------------------------------------------------------%

%-------------------Results Fig. 1 (c) and (d)----------------------------%
% Cleaning the workspace
clear     all;
% Loading results
load      coupled_complex_collinear
% Coherency of the true factors
A_norm    =     A.*repmat(1./sqrt(real(sum(conj(A).*A))),dim(1),1);
coh_A     =     max(max(abs(A_norm'*A_norm)-eye(R)));
B_norm    =     B.*repmat(1./sqrt(real(sum(conj(B).*B))),dim(2),1);
coh_B     =     max(max(abs(B_norm'*B_norm)-eye(R)));
C_norm    =     C.*repmat(1./sqrt(real(sum(conj(C).*C))),dim(3),1);
coh_C     =     max(max(abs(C_norm'*C_norm)-eye(R)));
A_p_norm  =     A_p.*repmat(1./sqrt(real(sum(conj(A_p).*A_p))),dim_p(1),1);
coh_A_p   =     max(max(abs(A_p_norm'*A_p_norm)-eye(R)));
B_p_norm  =     B_p.*repmat(1./sqrt(real(sum(conj(B_p).*B_p))),dim_p(2),1);
coh_B_p   =     max(max(abs(B_p_norm'*B_p_norm)-eye(R)));
% Fig.1 (a) or (c) coupled factors
figure
semilogy(SNR,total_mse_C_u,'k',...
     SNR,total_mse_C_p_u,'k:',...
     SNR,total_mse_C_c,'k--',...
     SNR,total_CRB_C_u,'b',...
     SNR,total_CRB_C_p_u,'b:',...
     SNR,total_CRB_C_c,'b--')
legend('MSE C uncoupled','MSE C_p uncoupled','MSE C coupled',...
       'CRB C uncoupled','CRB C_p uncoupled','CRB C coupled')
xlabel('SNR (dB)')
ylabel('Total MSE')
% Fig.1 (b) or (d) uncoupled factors
figure
semilogy(SNR,total_mse_AB_u,'k',...
     SNR,total_mse_AB_p_u,'k:',...
     SNR,total_mse_AB_c,'k--',...
     SNR,total_mse_AB_p_c,'k-.',...
     SNR,total_CRB_AB_u,'b',...
     SNR,total_CRB_AB_p_u,'b:',...
     SNR,total_CRB_AB_c,'b--',...
     SNR,total_CRB_AB_p_c,'b-.')
legend('MSE AB uncoupled','MSE AB_p uncoupled',...
       'MSE AB coupled','MSE AB_p coupled',...
       'CRB AB uncoupled','CRB AB_p uncoupled',...
       'CRB AB coupled','CRB AB_p coupled')
xlabel('SNR (dB)')
ylabel('Total MSE')
%-------------------------------------------------------------------------%